% Copyright (C) 2013 - 2015 - Michael Baudin
%
% This file must be used under the terms of the 
% Creative Commons Attribution-ShareAlike 3.0 Unported License :
% http://creativecommons.org/licenses/by-sa/3.0/


\section{Orthogonal polynomials}

In this section, we define the orthogonal polynomials which are 
used in the context of polynomial chaos decomposition. 
We first present the weight function which defines the orthogonality of 
the square integrable functions. 
Then we analyze the link between orthogonal polynomials 
and quadrature. 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Definitions and examples}

We will denote by $I$ an interval in $\RR$. 
The interval $[a,b]$ is the set of real numbers such that $x\geq a$ and 
$x\leq b$, for two real numbers $a$ and $b$. 
The open interval $(-\infty,+\infty)$ is also considered as an interval, 
although its boundaries are infinite. 
The half-open intervals $(-\infty,b)$ and $(a,+\infty)$ are also valid intervals.

\index{Weight function}
\begin{definition}
(\emph{Weight function of $\RR$})
\label{def-weight}
Let $I$ be an interval in $\RR$. 
A weight function $w$ is a nonnegative continuous integrable 
function of $x\in I$. 
\end{definition}

\begin{example}
(\emph{Weight function for Hermite polynomials})
The weight function for Hermite polynomials is
\begin{eqnarray}
\label{eq-Hermite-weight}
w(x)=\exp\left(-\frac{x^2}{2}\right),
\end{eqnarray}
for $x\in\RR$. 
This function is presented in the figure \ref{fig-gaussw}.
Clearly, this function is differentiable and nonnegative, since $\exp(-x^2)>0$, for 
any finite $x$.
The integral 
\begin{eqnarray}
\label{eq-Hermite-integ}
\int_\RR \exp(-x^2/2) dx =\sqrt{2 \pi}
\end{eqnarray}
is called the Gaussian integral (see the proposition \ref{prop-gaussinteg}
for the proof).
\end{example}

\begin{figure}
\begin{center}
\includegraphics[width=0.6\textwidth]{figures/gaussw.pdf}
\end{center}
\caption{The Gaussian weight function $w(x)=\exp(-x^2/2)$.}
\label{fig-gaussw}
\end{figure}

\begin{definition}
(\emph{Weighted $L^2$ space in $\RR$})
\label{def-weightedl2}
Let $I$ be an interval in $\RR$ and let $L^2_w(I)$ be the set of 
functions $g$ which are square integrable with respect to the weight 
function $w$, i.e. such that the integral 
\begin{eqnarray}
\label{eq-weightedl2}
\|g\|^2 = \int_I g(x)^2 w(x) dx
\end{eqnarray}
is finite. 
In this case, the norm of $g$ is $\|g\|$.
\end{definition}

\begin{example}
(\emph{Functions in $L^2_w(\RR)$})
Consider the Gaussian weight $w(x)=\exp(-x^2/2)$, for $x\in\RR$. 
Obviously, the function $g(x)=1$ is in $L^2_w(\RR)$. 

Now consider the function
\begin{eqnarray*}
g(x)=x
\end{eqnarray*}
for $x\in\RR$. 
The proposition \ref{prop-wintineven} (see in appendix) 
proves that
\begin{eqnarray*}
\int_\RR x^2 \exp(-x^2/2) dx =\sqrt{2\pi}.
\end{eqnarray*}
Therefore, $g\in L^2_w(\RR)$.
\end{example}

\begin{definition}
(\emph{Inner product in $L^2_w(I)$ space})
\label{def-scalprodl2w}
For any $g,h\in L^2_w(I)$, the inner product of $g$ and $h$ is
\begin{eqnarray}
\label{eq-scalprodl2w}
\lwdotprod{g}{h}=\int_I g(x) h(x) w(x) dx.
\end{eqnarray}
\end{definition}

Assume that $g\in L^2_w(I)$.
We can combine the equations \ref{eq-weightedl2} and \ref{eq-scalprodl2w}, which 
implies that the $L^2_w(I)$ norm of $g$ can be expressed as an inner product:
\begin{eqnarray}
\label{eq-scalprodl2w2}
\|g\|^2 = \lwdotprod{g}{g}.
\end{eqnarray}

\begin{example}
(\emph{Inner product in $L^2_w(\RR)$})
Consider the Gaussian weight $w(x)=\exp(-x^2/2)$, for $x\in\RR$. 
Then consider the function $g(x)=1$ and $h(x)=x$.
We have
\begin{eqnarray*}
\int_\RR g(x) h(x) w(x) dx 
&=& \int_\RR x \exp(-x^2/2) dx \\
&=& \int_{-\infty}^0 x \exp(-x^2/2) dx + \int_{0}^\infty x \exp(-x^2/2) dx.
\end{eqnarray*}
However,
\begin{eqnarray*}
\int_{-\infty}^0 x \exp(-x^2/2) dx = - \int_{0}^\infty x \exp(-x^2/2) dx,
\end{eqnarray*}
after the change of variable $y=-x$.
Therefore,
\begin{eqnarray*}
\int_\RR g(x) h(x) w(x) dx 
&=& 0,
\end{eqnarray*}
which implies $\lwdotprod{g}{h}=0$.
\end{example}

The $L^2_w(I)$ space is a Hilbert space.

\begin{definition}
(\emph{Orthogonality in $L^2_w(I)$ space})
\label{def-orthogonalityl2w}
Let $I$ be an interval of $\RR$. 
Let $g$ and $h$ be two functions in $L^2_w(I)$. 
The functions $g$ and $h$ are orthogonal if 
\begin{eqnarray*}
\lwdotprod{g}{h}=0.
\end{eqnarray*}
\end{definition}

\begin{definition}
(\emph{Polynomials})
\label{def-polymonic}
We denote by $\PP_n$ the set of real polynomials with 
degree $n$, i.e. $p_n\in\PP_n$ if :
\begin{eqnarray}
\label{def-poly}
p_n(x)=a_{n+1} x^n + a_n x^{n-1} + \ldots + a_1,
\end{eqnarray}
for any $x\in I$, where $a_{n+1}$, $a_n$,..., $a_1$ are 
real numbers. 
In this case, the degree of the polynomial $p_n$ is $n$.

If the leading term is $a_{n+1}=1$, then we say that the polynomial 
$p_n$ is monic. 
\end{definition}

\begin{definition}
(\emph{Orthogonal polynomials})
The set of polynomials $\{p_n\}_{n\geq 0}$ are orthogonal polynomials if 
$p_n$ is a polynomial of degree $n$ and:
\begin{eqnarray*}
\lwdotprod{p_i}{p_j}=0
\end{eqnarray*}
for $i\neq j$.
\end{definition}

In this orthogonality context, we will use the Kronecker symbol. 

\begin{definition}
(\emph{Kronecker symbol})
For any integers $i$ and $j$, the Kronecker symbol is 
\begin{eqnarray}
\label{eqn-defkron}
\delta_{ij} = \left\{
\begin{array}{ll}
1 & \textrm{ if } i=j, \\
0 & \textrm{ otherwise.}
\end{array}
\right.
\end{eqnarray}
\end{definition}


\begin{definition}
\label{def-orthopoly}
(\emph{Orthonormal polynomials})
The set of polynomials $\{p_n\}_{n\geq 0}$ are orthonormal polynomials if 
$p_n$ is a polynomial of degree $n$ and:
\begin{eqnarray*}
\lwdotprod{p_i}{p_j}=\delta_{ij}
\end{eqnarray*}
for $i\neq j$.
\end{definition}

We assume that, for all orthogonal polynomials, the degree zero polynomial $P_0$ is 
equal to one:
\begin{eqnarray}
\label{eq-integpoly0}
P_0(x) = 1,
\end{eqnarray}
for any $x\in I$. 

\begin{proposition}
(\emph{Integral of orthogonal polynomials})
\label{prop-integpoly}
Let $\{p_n\}_{n\geq 0}$ be orthogonal polynomials. 
We have 
\begin{eqnarray}
\label{eq-integpoly}
\int_I P_0(x) w(x) dx 
&=& \int_I w(x) dx 
\end{eqnarray}
Moreover, for $n\geq 1$, we have
\begin{eqnarray}
\label{eq-integpoly2}
\int_I p_n(x) w(x) dx 
&=& 0
\end{eqnarray}
\end{proposition}

\begin{proof}
The equation \ref{eq-integpoly} is the straightforward consequence of \ref{eq-integpoly0}. 
Moreover, for any $n\geq 1$, we have
\begin{eqnarray*}
\int_I p_n(x) w(x) dx 
&=& \int_I P_0(x) p_n(x) w(x) dx \\
&=& \lwdotprod{P_0(x)}{p_n(x)} \\
&=& 0,
\end{eqnarray*}
by the orthogonality property.
\end{proof}

The figure \ref{fig-hermitew} presents the function $He_n(x)w(x)$, for $n=0,1,...,5$, 
where $w$ is the Gaussian weight $w(x)=\exp(-x^2/2)$ 
and $He_n$ is the Hermite polynomial of degree $n$ (which will be 
defined precisely in the next section).
The proposition \ref{prop-integpoly} states that the only $n$ for which the integral 
is nonzero is $n=0$. 
Indeed, for $n\geq 1$, we can see that the area above zero is 
equal to the area below zero.
This is more obvious for $n=1,3,5$, i.e. for $n$ odd, 
because the function $He_n(x)$ is antisymmetric, i.e. $He_n(-x)=-He_n(x)$.

\begin{figure}
\begin{center}
\includegraphics[width=\textwidth]{figures/HermiteW05}
\end{center}
\caption{
The function $He_n(x)w(x)$, for $n=0,1,...,5$, 
and the Gaussian weight $w(x)=\exp(-x^2/2)$.
}
\label{fig-hermitew}
\end{figure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Orthogonal polynomials for probabilities}
\label{sec-probaorth}

In this section, we present the properties of $p_n(X)$, 
when $X$ is a random variable associated with the orthogonal polynomials 
$\{p_n\}_{n\geq 0}$.

\index{Distribution function}
\begin{proposition}
(\emph{Distribution from a weight})
\label{def-distrw}
Let $I$ be an interval in $\RR$ and let $w$ be a weight function on $I$. 
The function:
\begin{eqnarray}
\label{eq-unifw}
f(x) = \frac{w(x)}{\int_I w(x) dx},
\end{eqnarray}
for any $x\in I$, is a distribution function.
\end{proposition}

\begin{proof}
Indeed, its integral is equal to one:
\begin{eqnarray*}
\int_I f(x) dx 
&=& \frac{1}{\int_I w(x) dx} \int_I w(x) dx \\
&=& 1, 
\end{eqnarray*}
which concludes the proof.
\end{proof}

\begin{example}
(\emph{Distribution function for Hermite polynomials})
The equations \ref{eq-Hermite-weight} and \ref{eq-Hermite-integ} 
imply that the distribution function for Hermite polynomials is
\begin{eqnarray*}
f(x)=\frac{1}{\sqrt{2 \pi}} \exp\left(-\frac{x^2}{2}\right),
\end{eqnarray*}
for $x\in\RR$. 
The function $f(x)$ is presented in the figure \ref{fig-gaussf}.
\end{example}

\begin{figure}
\begin{center}
\includegraphics[width=0.6\textwidth]{figures/gausspdf.pdf}
\end{center}
\caption{The Gaussian distribution function $f(x)=\frac{1}{\sqrt{2\pi}} \exp(-x^2/2)$.}
\label{fig-gaussf}
\end{figure}

\begin{proposition}
(\emph{Expectation of orthogonal polynomials})
\label{prop-expecpoly}
Let $\{p_n\}_{n\geq 0}$ be orthogonal polynomials. 
Assume that $X$ is a random variable associated with the probability distribution 
function $f$, derived from the weight function $w$. 
We have 
\begin{eqnarray}
\label{eq-expecpoly1}
E(P_0(X))=1.
\end{eqnarray}
Moreover, for $n\geq 1$, we have
\begin{eqnarray}
\label{eq-expecpoly2}
E(p_n(X))&=& 0.
\end{eqnarray}
\end{proposition}

\begin{proof}
By definition of the expectation, 
\begin{eqnarray*}
E(P_0(X)) 
&=& \int_I P_0(x) f(x) dx \\
&=& \int_I f(x) dx \\
&=&1,
\end{eqnarray*}
since $f$ is a distribution function.
Moreover, for any $n\geq 1$, we have
\begin{eqnarray*}
E(p_n(X))
&=& \int_I p_n(x) f(x) dx \\
&=& \frac{1}{\int_I w(x) dx} \int_I p_n(x) w(x) dx \\
&=& 0,
\end{eqnarray*}
where the first equation derives from the equation \ref{eq-unifw}, 
and the second equality is implied by \ref{eq-integpoly2}.
\end{proof}

\begin{proposition}
(\emph{Variance of orthogonal polynomials})
\label{prop-varpoly}
Let $\{p_n\}_{n\geq 0}$ be orthogonal polynomials. 
Assume that $x$ is a random variable associated with the probability distribution 
function $f$, derived from the weight function $w$. 
We have 
\begin{eqnarray}
\label{eq-varpoly1}
V(P_0(X))=0.
\end{eqnarray}
Moreover, for $n\geq 1$, we have
\begin{eqnarray}
\label{eq-varpoly2}
V(p_n(X))&=& \frac{\|p_n\|^2}{\int_I w(x) dx}.
\end{eqnarray}
\end{proposition}

\begin{proof}
The equation \ref{eq-varpoly1} is implied by the fact that $P_0$ is a constant. 
Moreover, for $n\geq 1$, we have:
\begin{eqnarray*}
V(p_n(X))
&=& E\left(\left(p_n(X)-E(p_n(X))\right)^2\right) \\
&=& E\left(p_n(X)^2\right) \\
&=& \int_I p_n(x)^2 f(x) dx \\
&=& \frac{1}{\int_I w(x)dx} \int_I p_n(x)^2 w(x) dx,
\end{eqnarray*}
where the second equality is implied by the equation \ref{eq-expecpoly2}. 
\end{proof}

% \begin{figure}
% \begin{center}
% \includegraphics[width=\textwidth]{figures/HermiteHisto}
% \end{center}
% \caption{
% Histogram of $N=10000$ outcomes of $He_n(X)$, 
% where $X$ is a standard normal random variable, 
% for $n=0,1,...,5$.
% }
% \label{fig-HermiteHisto}
% \end{figure}

\begin{example}
In order to experimentally check the propositions \ref{prop-expecpoly} 
and \ref{prop-varpoly}, we consider Hermite polynomials. 
We generate 10000 pseudo random outcomes of a standard normal variable $X$, 
and compute $He_n(X)$. 
% The figure \ref{fig-HermiteHisto} presents the empirical histograms 
% of $He_n(X)$, for $n=0,1,...,5$.
% The histogram for $n=0$ is centered on $X=1$, since $He_0(x)=1$. 
% This confirms that $E(He_0(X))=1$ and $V(He_0(X))=0$. 
% The histograms for $n=1,3,5$ are symmetric, which is consistent with the 
% fact that $E(He_n(X))=0$, for $n\geq 1$. 
In the following Scilab session, the first column prints $n$, the 
second column prints the empirical mean, 
the third column prints the empirical variance and the last 
column prints $n!$, which is the exact variance.
\lstset{language=scilabscript}
\begin{lstlisting}
    n     mean(X)      variance(X)  n!
    0.    1.           0.           1.  
    1.    0.0041817    0.9978115    1.  
    2.  - 0.0021810    2.0144023    2.  
    3.    0.0179225    6.1480027    6.  
    4.    0.0231110    24.483042    24.  
    5.  - 0.0114358    112.13277    120.  
\end{lstlisting}
\end{example}

\begin{proposition}
\label{prop-exppipj}
Let $\{p_n\}_{n\geq 0}$ be orthogonal polynomials. 
Assume that $x$ is a random variable associated with the probability distribution 
function $f$, derived from the weight function $w$. 
For two integers $i,j\geq 0$, we have 
\begin{eqnarray}
\label{eq-exppipj1}
E(p_i(X)p_j(X))=0
\end{eqnarray}
if $i\neq j$. 
Moreover, if $i\geq 1$, then  
\begin{eqnarray}
\label{eq-exppipj2}
E(p_i(X)^2) = V(p_i(X)).
\end{eqnarray}
\end{proposition}

\begin{proof}
We have 
\begin{eqnarray*}
E(p_i(X)p_j(X))
&=& \int_I p_i(x) p_j(x) f(x) dx \\
&=& \frac{1}{\int_I w(x)dx} \int_I p_i(x) p_j(x) w(x) dx \\
&=& \frac{\lwdotprod{p_i}{p_j}}{\int_I w(x)dx}. 
\end{eqnarray*}
If $i\neq j$, the orthogonality of the polynomials implies \ref{eq-exppipj1}. 
If, on the other hand, we have $i=j\geq 1$, then 
\begin{eqnarray*}
E(p_i(X)^2) 
&=& \frac{\lwdotprod{p_i}{p_i}}{\int_I w(x)dx} \\
&=& \frac{\|p_i\|^2}{\int_I w(x)dx}. 
\end{eqnarray*}
We then use the equation \ref{eq-varpoly2}, which leads to 
the equation \ref{eq-exppipj2}.
\end{proof}


In the next sections, we review a few orthogonal polynomials 
which are important in the context of polynomial chaos.
The table \ref{fig-overortho} summarizes the results.

\begin{figure}
\begin{center}
\begin{tabular}{lllllll}
\hline
Distrib. & Support & Poly. & $w(x)$ & $f(x)$ & $\|p_n\|^2$ & $V(p_n)$\\
\hline
$\mathcal{N}(0,1)$ & $\RR$ & Hermite & $\exp\left(-\frac{x^2}{2}\right)$ & $\frac{1}{\sqrt{2\pi}}\exp\left(-\frac{x^2}{2}\right)$ & $\sqrt{2\pi} n!$ & $n!$\\
$\mathcal{U}(-1,1)$ & $[-1,1]$ & Legendre & $1$ & $\frac{1}{2}$ & $\frac{2}{2n+1}$ & $\frac{1}{2n+1}$ \\
$\mathcal{E}(1)$ & $\RR^+$ & Laguerre & $\exp(-x)$ & $\exp(-x)$ & $1$ & $1$ \\
\hline
\end{tabular}
\end{center}
\caption{Some properties of orthogonal polynomials.}
\label{fig-overortho}
\end{figure}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Quadrature and the Lagrange polynomial}
\label{sec-lagrangepoly}

In this section, we show that Lagrange interpolation 
with $n+1$ nodes leads to quadrature rules of maximum degree 
equal to $n$.

Assume that we want to compute :
\begin{eqnarray}
\label{eq-quadinteg}
I(f)=\int_I f(x)w(x)dx.
\end{eqnarray}

\begin{definition}
(\emph{Quadrature rule})
\label{def-quadrule}
Let $x_1,x_2,...,x_{n+1}$ be $n+1$ real numbers in the interval 
$I$ called the \emph{quadrature nodes}. 
Let $\alpha_1,\alpha_2,...,\alpha_{n+1}$ be $n+1$ nonnegative 
real numbers called the \emph{weights}. 
A quadrature rule is a formula :
\begin{eqnarray}
\label{eq-quadrule}
I_n(f)=\sum_{i=1}^{n+1} \alpha_i f(x_i),
\end{eqnarray}
to approximate $I(f)$.
\end{definition}




\begin{definition}
(\emph{Lagrange interpolation polynomial})
\label{def-lagrangepoly}
Let $l_i$ be the polynomial :
\begin{eqnarray}
\label{eq-lagli}
l_i(x) = \prod_{\substack{j=1\\j\neq i}}^{n+1} \frac{x-x_j}{x_i-x_j},
\end{eqnarray}
for any $x\in I$.
The Lagrange interpolating polynomial is 
\begin{eqnarray}
\label{eq-lagpoly}
\pi_n(x) = \sum_{i=1}^{n+1} f(x_i) l_i(x),
\end{eqnarray}
for any $x\in I$.
\end{definition}

\begin{definition}
(\emph{Degree of exactness})
\label{def-degexact}
The degree of exactness of a quadrature rule is $d$ if 
$d$ is the largest degree for which we have 
\begin{eqnarray}
\label{eq-degexact}
I(p_d)=I_n(p_d),
\end{eqnarray}
for any polynomial $p_d\in\PP_d$.
\end{definition}

In other words, the degree of exactness of a quadrature rule 
is the degree of the polynomial of largest degree that the 
rule integrates exactly. 

\begin{proposition}
(\emph{Degree of exactness of Lagrange interpolation})
\label{def-degexactlagrange}
If 
\begin{eqnarray}
\label{eq-degexactlagrange}
\alpha_i = \int_I l_i(x)w(x) dx
\end{eqnarray}
for $i=1,2,...,n+1$, therefore the degree of exactness of the 
associated quadrature rule is at least $n$. 

In this case, we say that the quadrature rule is interpolatory. 
\end{proposition}

The previous proposition implies that the weights of Lagrange 
integration must be chosen according to the equation 
\ref{eq-degexactlagrange}, but this does not impose any 
condition on the nodes. 

\begin{proof}
Let $p_n\in\PP_n$ be a degree $n$ polynomial. 
Let $\pi_n$ be the Lagrange interpolating polynomial for 
$p_n$. 
Since these are two degree $n$ polynomials 
equal at $n+1$ points, the polynomial $\pi_n$ is equal to $p_n$, 
i.e. $p_n(x) = \pi_n(x)$, for any $x\in I$. 
Therefore, the equation \ref{eq-lagpoly} implies :
\begin{eqnarray*}
I(p_n)
&=& \int_I p_n(x) w(x) dx \\
&=& \int_I \pi_n(x) w(x) dx \\
&=& \int_I \left( \sum_{i=1}^{n+1} p_n(x_i) l_i(x) \right) w(x) dx \\
&=& \sum_{i=1}^{n+1} p_n(x_i)  \int_I l_i(x)  w(x) dx \\
&=& \sum_{i=1}^{n+1} p_n(x_i)  \alpha_i \\
&=& I_n(p_n)
\end{eqnarray*}
where we have use the equation \ref{eq-degexactlagrange} in the 
next to last equality. 
\end{proof}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Gaussian quadrature and orthogonal polynomials}
\label{sec-quadorthopoly}

In this section, we show that we can achieve a greater 
degree of exactness by carefully choosing the nodes of the 
quadrature. 
This procedure leads to orthogonal polynomials and Gaussian 
quadrature. 

\begin{definition}
(\emph{Node polynomial})
\label{def-nodalpoly}
The node polynomial is 
\begin{eqnarray}
\label{eq-nodalpoly}
\omega_{n+1}(x) = \prod_{i=1}^{n+1} (x-x_i),
\end{eqnarray}
for any $x\in I$. 
\end{definition}

\begin{proposition}
(\emph{Polynomial division})
\label{def-polydiv}
Let $n$ and $m$ be two integers. 
Let $a_{n+m} \in\PP_{n+m}$ and $b_m\in\PP_m$. 
There exists a quotient $q_n\in\PP_n$ and a remainder $r_{m-1}\in\PP_{m-1}$ 
such that the division of the polynomial $a_{n+m}$ by the 
polynomial $b_m$ is 
\begin{eqnarray}
\label{eq-polydiv}
a_{n+m} = q_nb_m + r_{m-1}.
\end{eqnarray}
\end{proposition}

This proposition will not be proved here (see 
\cite{artcomputerKnuthVol2}, section 4.6 "Polynomial 
arithmetic" for more details on this topic). 

The following proposition is due to Jacobi (1826).

\begin{proposition}
(\emph{Conditions for maximum degree of exactness})
\label{def-maximalquad}
Let $m>0$ be and integer. 
The quadrature rule \ref{eq-quadrule} has degree of exactness 
$n+m$ if and only if 
\begin{enumerate}
\item the formula \ref{eq-quadrule} is interpolatory, 
\item for any $p_{m-1} \in \PP_{m-1}$, we have 
\begin{eqnarray}
\label{eq-maximalquad}
\int_I \omega_{n+1}(x) p_{m-1}(x) w(x) dx = 0.
\end{eqnarray}
\end{enumerate}
\end{proposition}

\begin{proof}
In the first part of this proof, let us assume that the 
conditions 1 and 2 are satisfied. 
We must prove that the quadrature 
rule has degree of exactness equal to $n+m$. 
Let $f\in\PP_{n+m}$. 
We must prove that  
\begin{eqnarray}
\label{eq-maximalquad1}
I(f)=I_n(f).
\end{eqnarray}
We can divide the polynomial $f$ by the polynomial $\omega_{n+1}$. 
The proposition \ref{def-polydiv} implies that there 
exists a quotient $q_{m-1}\in\PP_{m-1}$ and a remainder 
$r_n\in\PP_n$ such that :
\begin{eqnarray}
\label{eq-maximalquad2}
f=q_{m-1} \omega_{n+1} + r_n.
\end{eqnarray}
Since the quadrature rule is interpolatory, the quadrature 
rule is exact for $r_n$, which is a degree $n$ polynomial. 
Therefore, 
\begin{eqnarray}
\sum_{i=1}^{n+1} \alpha_i r_n(x_i)
&=& \int_I r_n(x) w(x)dx \nonumber \\
&=& \int_I f(x)w(x)dx - \int_I q_{m-1}(x) \omega_{n+1}(x)w(x) dx \nonumber \\
&=&\int_I f(x)w(x)dx \nonumber \\
&=& I(f), \label{eq-maximalquad3}
\end{eqnarray}
where the third equality is implied by the 
equation \ref{eq-maximalquad2} and the fourth is from the equation 
\ref{eq-maximalquad}.
The equation \ref{eq-maximalquad2} implies 
\begin{eqnarray*}
\sum_{i=1}^{n+1} \alpha_i r_n(x_i)
&=& \sum_{i=1}^{n+1} \alpha_i f(x_i) 
- \sum_{i=1}^{n+1} \alpha_i q_{m-1}(x_i) \omega_{n+1}(x_i) \\
&=& \sum_{i=1}^{n+1} \alpha_i f(x_i) \\
&=& I_n(f),
\end{eqnarray*}
since $\omega_{n+1}(x_i)=0$ for $i=1,...,n+1$. 
We combine the previous equation with the equation 
\ref{eq-maximalquad3} and get the equation \ref{eq-maximalquad1}, 
which concludes the first part of the proof. 

In the second part of the proof, let us assume that the 
quadrature rule has degree of exactness equal to $n+m$. 
We must prove that the conditions 1 and 2 are satisfied. 
By hypothesis, the quadrature rule is exact for the interpolating 
Lagrange polynomial (which has degree $n$), 
which implies that the condition 1 is satisfied. 
By the same reasoning as in the first part, we have 
\begin{eqnarray}
\sum_{i=1}^{n+1} \alpha_i r_n(x_i)
&=& I(f) - \int_I q_{m-1}(x) \omega_{n+1}(x) w(x) dx \nonumber \\
&=& I_n(f). \label{eq-maximalquad4}
\end{eqnarray}
By hypothesis, the quadrature rule has degree of exactness equal 
to $n+m$, which implies $I(f)=I_n(f)$. 
We plug this equality into \ref{eq-maximalquad4}, which implies 
that the condition 2 is satisfied, and concludes the proof.
\end{proof}

\begin{proposition}
(\emph{Maximum degree of exactness})
\label{def-maximaldeg}
The maximum degree of exactness of the quadrature rule 
\ref{eq-quadrule} is $2n+1$.
\end{proposition}

\begin{proof}
We are going to prove that $m\leq n+1$. 
Then the proposition \ref{def-maximalquad} 
implies that the maximum degree of exactness is $n+m=n+n+1=2n+1$. 

Let us prove this by contradiction : suppose that $m\geq n+2$. 
Then the equality \ref{eq-maximalquad} is true for $m=n+2$. 
Therefore $n+1=m-1$, which 
implies that the polynomial $\omega_{n+1}\in\PP_{n+1}=\PP_{m-1}$ 
satisfies the equality :
$$
\int_I \omega_{n+1}^2(x)w(x)dx=0.
$$
Since the weight $w$ is by hypothesis continuous, nonnegative 
and with a nonnegative integral, the previous equation 
implies that $\omega_{n+1}=0$, which is impossible. 
\end{proof}

We have seen that the maximum possible value of $m$ is $n+1$. 
Therefore, the equation \ref{eq-maximalquad} implies that the node 
polynomial $\omega_{n+1}$ must satisfy the equation :
\begin{eqnarray}
\int_I \omega_{n+1}(x) p_n(x) w(x) dx = 0, \label{eq-nodepolycond}
\end{eqnarray}
for any $p_n\in\PP_n$. 
In terms of scalar product, this writes :
\begin{eqnarray}
\lwdotprod{\omega_{n+1}}{p_n}=0, \label{eq-nodepolycond2}
\end{eqnarray}
for any $p_n\in\PP_n$. 
This leads to the following proposition. 
 
\begin{proposition}
(\emph{Orthogonality of the node polynomial})
\label{def-orthonode}
The maximal quadrature rule is so that the monic node polynomial 
is orthogonal to all polynomials of degree less or equal to $n$. 
\end{proposition}

\begin{definition}
(\emph{Gaussian quadrature})
\label{def-gaussquad}
If the integration nodes $x_1$, ..., $x_{n+1}$ are the 
roots of a node polynomial satisfying the equation \ref{eq-nodepolycond2}, 
the quadrature rule \ref{eq-quadrule} is called a 
Gaussian quadrature. 
\end{definition}

In the following, we denote by $\{\pi_k\}_{k=1,...,n}$ the 
monic node polynomials associated with the equation~\ref{eq-nodepolycond2}.

\begin{proposition}
(\emph{Properties of node polynomials})
\label{prop-propnodpoly}
\begin{enumerate}
\item The polynomials $\{\pi_k\}_{k=1,...,n}$ are orthogonals. 
\item They are linearly independent. 
\item The polynomials $\{\pi_k\}_{k=1,...,n}$ are a basis of $\PP_n$. 
\end{enumerate}
\end{proposition}

\begin{proof}
\begin{enumerate}
\item Let us prove that the polynomials $\{\pi_k\}_{k=1,...,n}$ are orthogonals. 
Consider two polynomials $\pi_i$ and $\pi_j$ satisfying the equation 
\ref{eq-nodepolycond2}, with $i\neq j$. 
Without loss of generality, we can assume that $i>j$ (otherwise, we 
just have to switch $i$ and $j$). 
Since $\pi_j$ has a degree lower than $\pi_i$, 
the equation \ref{eq-nodepolycond2} implies :
$$
\lwdotprod{\pi_i}{\pi_j}=0,
$$
which concludes the proof. 

\item The fact that the orthogonal polynomials $\{\pi_k\}_{k=1,...,n}$ 
are linearly independent is a result of linear algebra. 
Indeed, for any real numbers $\alpha_1$,..., $\alpha_n$, 
assume that 
$$
\alpha_1 \pi_1 + ... + \alpha_n \pi_n = 0.
$$
For any $i=1,...,n$, the scalar product of the previous equation 
with $\pi_i$ implies :
$$
\alpha_i (\pi_i,\pi_i)=0,
$$
since the other terms in the sum are zero, by orthogonality. 
Suppose $(\pi_i,\pi_i)= 0$. This would contradict the hypothesis 
that the weight $w$ is a continuous, nonnegative function. 
This implies that, necessarily, we have $(\pi_i,\pi_i)> 0$. 
We combine this inequality with the previous equality, 
and get $\alpha_i=0$, which shows that the orthogonal 
polynomials are linearily independent. 

\item Linear algebra shows that the polynomials $\{\pi_k\}_{k=1,...,n}$ 
are a basis of $\PP_n$. 
Indeed, consider the following set of polynomials :
$$
1, x, x^2, ..., x^n.
$$
The definition \ref{def-polymonic} shows that the previous polynomials 
are a basis of $\PP_n$, since any degree $n$ polynomial is equal 
to a linear combination of these $n$ polynomials. 
Therefore, the dimension of the vector space $\PP_n$ is $n$. 
However, the $n$ polynomials $\{\pi_k\}_{k=1,...,n}$ are linearly 
independent, which implies that these are a basis of $\PP_n$, and 
concludes the proof.
\end{enumerate}
\end{proof}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{The three term recurrence}
\label{sec-threetermrec}

In this section, we show that orthogonal polynomials satisfy a three 
term recurrence. 

\begin{proposition}
(\emph{Three term recurrence of monic orthogonal polynomials})
\label{prop-threeterm}
Assume $\{\pi_k\}_{k=-1,0,1,...,n}$ is a family of monic orthogonal 
polynomials, with 
$$
\pi_{-1}=0, \qquad \pi_0=1.
$$
Therefore, 
\begin{eqnarray}
\pi_{k+1}(x)=(x-\alpha_k)\pi_k(x) - \beta_k\pi_{k-1}(x),
\label{eq-threeterm1}
\end{eqnarray}
for $k=0,1,...,n$ and any $x\in I$, where 
\begin{eqnarray}
\alpha_k = \frac{(x\pi_k,\pi_k)}{(\pi_k,\pi_k)}
\label{eq-threeterm2}
\end{eqnarray}
for $k=0,1,...,n$ and 
\begin{eqnarray}
\beta_k = \frac{(\pi_k,\pi_k)}{(\pi_{k-1},\pi_{k-1})}
\label{eq-threeterm3}
\end{eqnarray}
for $k=1,2,...,n$.
\end{proposition}

In the previous proposition, let us make clear that the 
scalar product $(x\pi_k,\pi_k)$ in $\alpha_k$ involves the 
polynomial $x\pi_k(x)$, for any $x\in I$.

Notice that the proposition does not state the value of 
$\beta_0$, which can be chosen freely. 
Indeed, consider the equation \ref{eq-threeterm1} for $k=0$. 
We have 
\begin{eqnarray*}
\pi_1(x)
&=&(x-\alpha_0)\pi_0(x) - \beta_0\pi_{-1}(x) \\
&=&(x-\alpha_0)\pi_0(x),
\end{eqnarray*}
since $\pi_{-1}=0$. 
As in \cite{ANU:1770376}, we choose :
\begin{eqnarray}
\label{eq-defbeta0}
\beta_0=(\pi_0,\pi_0) = \int_I w(x)dx.
\end{eqnarray}

\begin{proof}
For any integer $k=1,...,n$, the polynomial $\pi_{k+1}-x\pi_k$ has degree 
lower or equal to $k$. 
Indeed, both $\pi_{k+1}$ and $\pi_k$ are monic, so that the leading term $x^{k+1}$ 
cancels. 
Since the orthogonal polynomials $\{\pi_0,\pi_1,...,\pi_k\}$ 
are a basis of $\PP_k$, we have 
\begin{eqnarray}
\label{eq-threeterm4}
\pi_{k+1}-x\pi_k = -\alpha_k \pi_k - \beta_k \pi_{k-1} 
-\sum_{j=0}^{k-2}\gamma_{kj}\pi_j,
\end{eqnarray}
for $k=0,1,...,n$, where $\alpha_k$, $\beta_k$ and $\gamma_{kj}$, 
for $j=0,...,k-2$, are real numbers. 

\begin{enumerate}
\item The scalar product of the equation \ref{eq-threeterm4} with $\pi_k$ 
is :
$$
-(x\pi_k,\pi_k)=-\alpha_k(\pi_k,\pi_k),
$$
since the orthogonality of the polynomials implies that the other 
terms in the sum are zero. 
The previous equation immediately leads to the equation \ref{eq-threeterm2}.

\item The scalar product of the equation \ref{eq-threeterm4} with $\pi_{k-1}$ 
is :
\begin{eqnarray}
\label{eq-threeterm5}
-(x\pi_k,\pi_{k-1})=-\beta(\pi_{k-1},\pi_{k-1}),
\end{eqnarray}
by the same orthogonality principle. 
However, the left hand side of the previous equation can be simplified, 
because :
\begin{eqnarray}
(x\pi_k,\pi_{k-1})
&=& \int_I x\pi_k(x) \pi_{k-1}(x) w(x)dx \nonumber \\
&=& (\pi_k,x\pi_{k-1}). \label{eq-threeterm6}
\end{eqnarray}
Moreover, the polynomial $x\pi_{k-1}$ is a monic degree $k$ polynomial. 
Hence, it can be decomposed as~:
$$
x\pi_{k-1} = \pi_k + c_k\pi_{k-1} + ... + c_1\pi_0,
$$
where $c_k$,...,$c_1$ are real numbers. 
By orthogonality, the scalar product of the previous equation with $\pi_k$ is :
$$
(\pi_k,x\pi_{k-1}) = (\pi_k,\pi_k).
$$
We plug the previous equation into \ref{eq-threeterm6}, which implies :
$$
(x\pi_k,\pi_{k-1}) = (\pi_k,\pi_k).
$$
The previous equation can be combined with \ref{eq-threeterm5}, which leads 
to \ref{eq-threeterm3}.

\item In order to prove the equation \ref{eq-threeterm1}, we are going 
to use the equation \ref{eq-threeterm4} and prove that, for any $j=0,1,...,k-2$, 
we have $\gamma_{kj}=0$.
Using orthogonality, the scalar product of the equation \ref{eq-threeterm4} with $\pi_j$ is :
$$
-(x\pi_k,\pi_j)=-\gamma_{kj}(\pi_j,\pi_j).
$$
Moreover, we have 
$$
(x\pi_k,\pi_j)=0
$$
since $x\pi_k$ is a degree $k+1$ polynomial and $j=0,1,...,k-2$. 
This leads to 
$$
\gamma_{kj}(\pi_j,\pi_j)=0.
$$
However, we know that $(\pi_j,\pi_j)>0$, which concludes the proof. 
\end{enumerate}
\end{proof}

The three-term recurrence \ref{eq-threeterm1} is for monic orthogonal 
polynomials. 
However, a set of polynomials can be orthogonal without being 
monic, as we are going to show in the next proposition. 

\begin{proposition}
(\emph{Three term recurrence of orthogonal polynomials})
\label{prop-threetermgen}
Assume $\{p_k\}_{k=-1,0,1,...,n}$ is a family of orthogonal 
polynomials, with 
\begin{eqnarray}
\label{eq-threetermgen0}
p_{-1}=0, \qquad p_0=\frac{1}{\gamma_0},
\end{eqnarray}
Therefore, 
\begin{eqnarray}
p_{k+1}(x)=\frac{\gamma_k}{\gamma_{k+1}} (x-\alpha_k)p_k(x) 
- \frac{\gamma_{k-1}}{\gamma_{k+1}} \beta_k p_{k-1}(x),
\label{eq-threetermgen1}
\end{eqnarray}
for $k=0,1,...,n$ and any $x\in I$, where 
\begin{eqnarray}
\alpha_k = \frac{(x p_k,p_k)}{(p_k,p_k)}
\label{eq-threetermgen2}
\end{eqnarray}
for $k=0,1,...,n$, 
\begin{eqnarray}
\beta_k = \frac{\gamma_k^2(p_k,p_k)}{\gamma_{k-1}^2(p_{k-1},p_{k-1})}
\label{eq-threetermgen3}
\end{eqnarray}
for $k=1,2,...,n$ and $\gamma_k$ is a nonzero real number which 
can be chosen arbitrarily. 
\end{proposition}

\begin{proof}
Any polynomial $p_k$ is the product of a monic polynomial 
$\pi_k$ with a nonzero real number. 
Indeed, consider the polynomials 
\begin{eqnarray}
p_k = \frac{\pi_k}{\gamma_k},
\label{eq-threetermgen4}
\end{eqnarray}
where $\pi_k$ is a monic orthogonal polynomial and $\gamma_k$ is a 
nonzero real number. 
We plug the equation $\pi_k=\gamma_k p_k$ into \ref{eq-threeterm1} and get :
\begin{eqnarray*}
\gamma_{k+1} p_{k+1}(x)
=(x-\alpha_k)\gamma_k p_k(x) - \beta_k\gamma_{k-1}p_{k-1}(x),
\end{eqnarray*}
for any $x\in I$. 
We divide the previous equation by $\gamma_{k+1}$, which leads 
to \ref{eq-threetermgen1}. 
We obtain the equations \ref{eq-threetermgen2} and \ref{eq-threetermgen3} 
using the same equation. 
\end{proof}

Finally, we can normalize the polynomials and get orthonormal 
polynomials as presented in the definition \ref{def-orthopoly}.
The following proposition is a straightforward consequence of 
the proposition \ref{prop-threeterm}. 
Notice that, as we normalize the polynomials, they are not monic 
anymore. 

\begin{proposition}
(\emph{Three term recurrence of orthonormal polynomials})
\label{prop-threetermnorm}
Assume $\{p_k\}_{k=-1,0,1,...,n}$ is a family of orthonormal 
polynomials, with 
\begin{eqnarray}
p_{-1}=0, \qquad p_0=\frac{1}{\sqrt{\beta_0}},
\label{eq-threetermnorm0}
\end{eqnarray}
where $\beta_0$ is defined by the equation \ref{eq-defbeta0}.
Therefore, 
\begin{eqnarray}
p_{k+1}(x)=\frac{x-\alpha_k}{\sqrt{\beta_{k+1}}}p_k(x) 
- \frac{\sqrt{\beta_k}}{\sqrt{\beta_{k+1}}} p_{k-1}(x),
\label{eq-threetermnorm1}
\end{eqnarray}
for $k=0,1,...,n$ and any $x\in I$, where 
\begin{eqnarray}
\alpha_k = (x p_k,p_k)
\label{eq-threetermnorm2}
\end{eqnarray}
for $k=0,1,...,n$, 
\begin{eqnarray}
\beta_k = \frac{\gamma_k^2}{\gamma_{k-1}^2}
\label{eq-threetermnorm3}
\end{eqnarray}
for $k=1,2,...,n$ and 
\begin{eqnarray}
\gamma_k = \|\pi_k\|=\sqrt{(\pi_k,\pi_k)}.
\label{eq-threetermnorm4}
\end{eqnarray}
\end{proposition}

\begin{proof}
We use the proposition \ref{prop-threetermgen} with 
$\gamma_k=\|p_k\|$.
The equation \ref{eq-threetermgen4} implies 
$$
\|p_k\| = \frac{\|\pi_k\|}{\|\pi_k\|} = 1,
$$
and 
$$
(p_k,p_k)=1. 
$$
We plug the previous equation into \ref{eq-threetermgen2} and 
get \ref{eq-threetermnorm2}. 
When we plug it into \ref{eq-threetermgen3}, we get 
\ref{eq-threetermnorm3}. 

Finally, the equation \ref{eq-threetermnorm3} implies :
\begin{eqnarray}
\frac{\gamma_k}{\gamma_{k+1}} = \frac{1}{\sqrt{\beta_{k+1}}}.
\label{eq-threetermnorm5}
\end{eqnarray}
The previous equation implies 
\begin{eqnarray*}
\beta_k \frac{\gamma_{k-1}}{\gamma_{k+1}} 
&=& \beta_k \frac{\gamma_{k-1}}{\gamma_k} \frac{\gamma_k}{\gamma_{k+1}} \\
&=& \beta_k \frac{1}{\sqrt{\beta_k}} \frac{1}{\sqrt{\beta_{k+1}}} \\
&=& \frac{\sqrt{\beta_k}}{\sqrt{\beta_{k+1}}}.
\end{eqnarray*}
We plug the previous equation and the equation \ref{eq-threetermnorm5} into 
\ref{eq-threetermgen1}, which implies \ref{eq-threetermnorm1}.
\end{proof}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Accuracy of roots of polynomials}
\label{sec-accuracyroots}

We could compute the nodes by searching for the 
roots of the orthogonal polynomials. 
As we are going to see, this method is very sensitive to small 
errors in the coefficients of the polynomial. 
Hence, if $n$ is sufficiently large, computing the roots 
of the polynomials fails to produce accurate nodes. 

Consider the Chebyshev polynomial of degree $n$. 
Its roots are given by the equation \ref{eq-chebynodes}, 
page \pageref{eq-chebynodes}. 
This is the equation used by the \scifun{chebyshev\_quadrature} 
function. 

The other method uses the \scifun{chebyshev\_poly} function 
(see the section \ref{sec-chebyshev}), which 
computes the Chebyshev polynomial. 
More precisely, Scilab uses a data structure based on its 
coefficients. 
It is then straightforward to use the \scifun{roots} function, 
which returns the roots of the polynomial, based on the 
eigenvalues of the companion matrix \cite{Edelman1994}. 
By definition, the companion matrix of the polynomial defined by 
the equation \ref{def-poly} is :
\begin{eqnarray*}
C(p)=
\begin{pmatrix}
0 & 0 & \ldots & 0 & -a_1/a_{n+1} \\
1 & 0 & \ldots & 0 & -a_2/a_{n+1} \\
0 & 1 & \ldots & 0 & -a_3/a_{n+1} \\
\vdots & \vdots & \ddots & \vdots & \vdots \\
0 & 0 & \ldots & 1 & -a_n/a_{n+1} \\
\end{pmatrix}.
\end{eqnarray*}

In the following script, we compute the roots of the 
Chebyshev polynomials from degree 2 to 50 by the 
two previous methods. 
Then we compute the number of common digits, using the 
\scifun{assert\_computedigits} function. 

\lstset{language=scilabscript}
\begin{lstlisting}
scf();
for n=2:50
    [x,w]=chebyshev_quadrature(n);
    p=chebyshev_poly(n);
    xp=real(roots(p));
    xp=gsort(xp,"g","i");
    if (modulo(n,2)==1) then
        x(abs(x)<1.e-7)=[];
        xp(abs(xp)<1.e-7)=[];
    end
    d=assert_computedigits(xp,x);
    dmin=min(d);
    mprintf("n=%d, dmin=%.1f\n",n,dmin)
    if (modulo(n,2)==0) then
        plot(n*ones(n,1),d,"bo")
    else
        plot((n-1)*ones(d),d,"bo")
    end
end
xtitle("Accuracy of Chebyshev roots");
xlabel("n");
ylabel("Number of accurate digits");
\end{lstlisting}

If $n$ is odd, then zero is an exact root. 
But in this case, the equation \ref{eq-chebynodes} produces 
a node which is close to $10^{-16}$, whereas the 
\scifun{roots} function produces a corresponding node 
which is exactly equal to zero. 
Since there is no common digit between these two 
nodes, and since both of them are sufficiently accurate 
with respect to the absolute accuracy that we can expect, 
we remove these nodes in the comparison. 

The previous script produces the figure \ref{fig-acccheby}. 
The figure shows that, when $n$ increases from 1 to 50, 
the accuracy of the roots computed with the \scifun{roots} 
function can decrease from 15 (the maximum) down to 1 digits 
(the minimum). 


\begin{figure}
\begin{center}
\includegraphics[width=0.6\textwidth]{figures/accuracy_chebyshev.pdf}
\end{center}
\caption{The accuracy of Chebyshev nodes.}
\label{fig-acccheby}
\end{figure}

For a given $n$, the accuracy generally decreases when the 
node is close to 1, as shown in the figure \ref{fig-acccheby2} 
for $n=50$ and $n=100$.

\begin{figure}
\begin{center}
\includegraphics[width=0.45\textwidth]{figures/accuracy_chebyshev-n50.pdf}
\includegraphics[width=0.45\textwidth]{figures/accuracy_chebyshev-n100.pdf}
\end{center}
\caption{The accuracy of Chebyshev nodes when $n=50$ and $n=100$.}
\label{fig-acccheby2}
\end{figure}

The case where $n=50$ is difficult to manage for the 
\scifun{roots} function. 
For example, the last two roots of the Chebyshev polynomial 
of degree 50 are :
\lstset{language=scilabscript}
\begin{lstlisting}
    1.00039787307992989  
    1.01163758359688472  
\end{lstlisting}
which are not even in the $[-1,1]$ interval. 

Although our method based on the \scifun{roots} function 
does not perform well in this case, this does not imply that 
the algorithm computing the roots is, by itself, the cause 
of the accuracy issue. 
Notice that the nonzero coefficients of the Chebyshev 
polynomial of degree 50 have a magnitude which range 
from 1 up to approximately $10^{18}$, with coefficients 
which alternate in sign. 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Computing the nodes and weights}
\label{sec-computenodes}

In this section, we analyze a method 
to accurately compute the nodes and weights of the quadrature 
rule. 

\begin{definition}
(\emph{Jacobi matrix})
\label{def-Jacobi}
The Jacobi matrix of order $n$ is 
$$
J_n=
\begin{pmatrix}
\alpha_0 & \sqrt{\beta_1} & & & 0 \\
\sqrt{\beta_1} & \alpha_1 & \sqrt{\beta_2} & & \\
 & \ddots & \ddots & \ddots & \\
 &  &  \sqrt{\beta_{n-1}} &  \alpha_{n-1} & \sqrt{\beta_{n}}\\
0 &  &  &  \sqrt{\beta_{n}} & \alpha_n
\end{pmatrix},
$$
for $n\geq 0$.
\end{definition}

Notice that the previous matrix is symmetric. 

\begin{proposition}
(\emph{Eigenvalues of the Jacobi matrix})
\label{prop-eigenjacobi}
The eigenvalues of the Jacobi matrix are the nodes of the quadrature 
rule, i.e. if $x$ is a node of the quadrature rule, therefore
\begin{eqnarray}
\label{eq-eigenjacobi1}
J_n \bp(x) = x\bp(x),
\end{eqnarray}
where 
\begin{eqnarray}
\bp = 
\begin{pmatrix}
p_0 \\
p_1\\
\vdots \\
p_n,
\end{pmatrix}
\label{eq-eigenjacobi2}
\end{eqnarray}
where $p_i$ is the orthonormal polynomial of degree $i$, 
for $i=0,...,n$. 
\end{proposition}

\begin{proof}
For $k=0,1,...,n$ and for any $x\in I$, the 
equation \ref{eq-threetermnorm1} implies :
\begin{eqnarray*}
\sqrt{\beta_{k+1}} p_{k+1}(x)
&=&(x-\alpha_k) p_k(x) - \sqrt{\beta_k} p_{k-1}(x) \\
&=&x p_k(x) -\alpha_k p_k(x)  - \sqrt{\beta_k} p_{k-1}(x).
\end{eqnarray*}
Therefore, 
\begin{eqnarray}
\label{eq-eigenjacobi3}
x p_k(x)
&=& \sqrt{\beta_k} p_{k-1}(x) +\alpha_k p_k(x)  
+ \sqrt{\beta_{k+1}} p_{k+1}(x).
\end{eqnarray}
In matrix terms, the definition of the Jacobi matrix and 
the equation \ref{eq-eigenjacobi2} implies :
\begin{eqnarray*}
J_n \bp 
&=& 
\begin{pmatrix}
\alpha_0 p_0 + \sqrt{\beta_1} p_1 \\
\sqrt{\beta_1} p_0 + \alpha_1 p_1 + \sqrt{\beta_2} p_2 \\
\vdots \\
\sqrt{\beta_{n-1}} p_{n-2} + \alpha_{n-1} p_{n-1} + \sqrt{\beta_n} p_n \\
\sqrt{\beta_{n}} p_{n-1} + \alpha_{n} p_{n}
\end{pmatrix} \\
&=& 
\begin{pmatrix}
x p_0 - \sqrt{\beta_{0}} p_{-1} \\
x p_1 \\
\vdots \\
x p_{n-1} \\
x p_{n} - \sqrt{\beta_{n+1}} p_{n+1}
\end{pmatrix}
,
\end{eqnarray*}
where we have used the equation \ref{eq-eigenjacobi3} in 
the last equality. 
First, the equation \ref{eq-threetermgen0} implies that 
the first row is equal to $x p_0$. 
Second, if $x$ is a root of $p_{n+1}$, then $p_{n+1}(x)=0$ 
which implies that the last row is equal to $x p_{n}$. 
This is why the previous equation implies the equation \ref{eq-eigenjacobi1}, 
which concludes the proof.
\end{proof}

\begin{proposition}
(\emph{Weights from the design matrix})
\label{prop-weightsdesign}
Consider the vectors $\alpha,\bv\in RR^{n+1}$, 
defined by :
\begin{eqnarray}
\alpha = 
\begin{pmatrix}
\alpha_1 \\
\vdots \\
\alpha_{n+1}
\end{pmatrix}
,\qquad 
\bv = 
\begin{pmatrix}
\sqrt{\beta_0} \\
0 \\
\vdots \\
0
\end{pmatrix}
.
\label{eq-weightsdesign3}
\end{eqnarray}
The weights of the quadrature rule satisfy the equality 
\begin{eqnarray}
P\alpha = \bv,
\label{eq-weightsdesign1}
\end{eqnarray}
where $P$ is a $n+1$ by $n+1$ design matrix which entries are :
\begin{eqnarray}
p_{ij} = p_{i-1}(x_j),
\label{eq-weightsdesign2}
\end{eqnarray}
for $i,j=1,2,...,n+1$ where $p_0,...,p_n$ are orthonormal 
polynomials.
\end{proposition}

\begin{proof}
For $i=0,...,n$, the quadrature rule \ref{eq-quadrule} integrates 
$p_i$ exactly, since $p_i$ is a polynomial of degree lower than 
$2n+1$. 
Therefore, 
$$
\int_I p_i(x)w(x) dx = \sum_{j=1}^{n+1}\alpha_j p_i(x_j),
$$
for $i=0,...,n$. 
However, the equation \ref{eq-threetermnorm0} implies :
\begin{eqnarray*}
\int_I p_i(x)w(x) dx
&=& \sqrt{\beta_0} \int_i p_i(x) p_0(x)w(x)dx \\
&=& \sqrt{\beta_0} (p_i,p_0).
\end{eqnarray*}
Therefore, 
$$
\sum_{j=1}^{n+1}\alpha_j p_i(x_j)
=\sqrt{\beta_0} (p_i,p_0)
$$
for $i=0,...,n$.
The previous expression is equal to $\sqrt{\beta_0}$ 
if $i=0$ and is equal to zero otherwise, which concludes the 
proof. 
\end{proof}

\begin{proposition}
(\emph{Weights from Jacobi's matrix})
\label{prop-weightsjacobi}
For any $i=1,...,n+1$, suppose that $x_i$ is a node 
of the quadrature rule. 
Assume that $\bu_i$ is the normalized eigenvector associated 
with the eigenvalue $x_i$ of $J_n$, i.e. assume that 
\begin{eqnarray}
\label{eq-weightsjacobi1}
J_n \bu_i = x_i\bu_i,
\end{eqnarray}
where 
\begin{eqnarray}
\label{eq-weightsjacobi2}
\|\bu_i\|_2 = 1.
\end{eqnarray}
Therefore, the weights of the quadrature rule satisfy the 
equation 
\begin{eqnarray}
\label{eq-weightsjacobi3}
\alpha_i = \beta_0 u_{1i}^2.
\end{eqnarray}
\end{proposition}

\begin{proof}
Consider the matrix $P$ defined by the equation \ref{eq-weightsdesign2}. 
Its columns are 
$$
P=(\bp(x_1),...,\bp(x_{n+1})),
$$
where the column vector $\bp(x_i)$ is defined by the equation 
\ref{eq-eigenjacobi2}. 
The matrix $J_n$ is symmetric and linear algebra theory 
implies that its eigenvectors are orthogonal. 
Therefore, the proposition \ref{prop-eigenjacobi}, which 
states that the columns of $P$ are the eigenvectors 
of $J_n$, implies that the columns of $P$ are orthogonal. 

Therefore, the matrix $P^TP$ is diagonal :
\begin{eqnarray}
\label{eq-weightsjacobi4}
P^TP = diag(d_1,...,d_{n+1}),
\end{eqnarray}
where 
\begin{eqnarray*}
d_i
&=&\sum_{j=1}^{n+1} p_{ji}^T p_{ij} \\ 
&=&\sum_{j=1}^{n+1} p_{ij} p_{ij} \\ 
&=&\sum_{j=1}^{n+1} p_{j-1}^2(x_i),
\end{eqnarray*}
which implies :
\begin{eqnarray}
\label{eq-weightsjacobi6}
d_i =\sum_{j=0}^{n} p_{j}^2(x_i).
\end{eqnarray}

We left multiply the equation \ref{eq-weightsdesign1} by $P^T$, 
which implies 
$$
P^T P \alpha = P^T \bv.
$$
We insert the equation \ref{eq-weightsjacobi4} into the previous 
equality, and get :
\begin{eqnarray}
\label{eq-weightsjacobi5}
D \alpha = P^T \bv.
\end{eqnarray}
However, the equation \ref{eq-threetermnorm0} implies that 
the first row of $P$ is :
$$
(p_0(x_1),...,p_0(x_{n+1}))
=\left(\frac{1}{\sqrt{\beta_0}},...,\frac{1}{\sqrt{\beta_0}}\right),
$$
which is also the first column of $P^T$. 
The equation \ref{eq-weightsdesign3} then leads to :
$$
P^T \bv
= 
\begin{pmatrix}
\frac{\sqrt{\beta_0}}{\sqrt{\beta_0}}\\
\vdots \\
\frac{\sqrt{\beta_0}}{\sqrt{\beta_0}}
\end{pmatrix}
= 
\begin{pmatrix}
1\\
\vdots \\
1
\end{pmatrix}.
$$
Therefore, the equation \ref{eq-weightsjacobi5} implies :
$$
d_i \alpha_i = 1,
$$
for $i=1,...,n+1$. 
We substitute $d_i$ from the equation \ref{eq-weightsjacobi6} into 
the previous equation and get :
\begin{eqnarray}
\label{eq-weightsjacobi7}
\alpha_i = \frac{1}{\sum_{j=0}^{n} p_{j}^2(x_i)},
\end{eqnarray}
for $i=1,...,n+1$. 

Consider the equation \ref{eq-eigenjacobi1}, where $\bp(x_i)$ 
is an eigenvector of $J_n$ and $x_i$ is a node of the quadrature 
rule. 
Let $\bu_i\in\RR^{n+1}$ be a normalized eigenvector of the Jacobi 
matrix :
\begin{eqnarray*}
\bu_i
&=&\frac{\bp(x_i)}{\|\bp(x_i)\|_2} \\
&=& \frac{\bp(x_i)}{\sqrt{\sum_{j=0}^n p_j^2(x_i)}}.
\end{eqnarray*}
The first component of the previous vector is 
\begin{eqnarray*}
u_{1i}
&=& \frac{p_0(x)}{\sqrt{\sum_{j=0}^n p_j^2(x_i)}} \\
&=& \frac{1}{\sqrt{\sum_{j=0}^n p_j^2(x_i)}} \frac{1}{\sqrt{\beta_0}}, 
\end{eqnarray*}
after the equation \ref{eq-threetermnorm0}. 
We square the previous equation and get :
\begin{eqnarray*}
\beta_0 u_{1i}^2
&=& \frac{1}{\sum_{j=0}^n p_j^2(x_i)}.
\end{eqnarray*}
We combine the previous equation and \ref{eq-weightsjacobi7}, 
which leads to \ref{eq-weightsjacobi3}.
\end{proof}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Sturm-Liouville equations}
\label{sec-Sturm}

\begin{definition}
(\emph{Sturm-Liouville equation})
\label{def-Sturm}
Let $p$, $q$, and $w$ be functions on $\RR$, with $w(x)>0$, for 
any $x\in \RR$. 
The differential equation 
\begin{eqnarray*}
\frac{d}{dx} \left( p(x)\frac{dy}{dx}\right) + q(x)y = -\lambda w(x) y,
\end{eqnarray*}
where $y$ is a function of $x$ is called a Sturm-Liouville 
equation. 
\end{definition}

Let $L$ be the differential operator defined by :
\begin{eqnarray*}
L = \frac{1}{w(x)} \left(- \frac{d}{dx} \left( p(x)\frac{d}{dx}\right) + q(x)\right).
\end{eqnarray*}
The operator $L$ is called Sturm-Liouville operator. 
The S-L differential equation is the eigenvalue equation~:
\begin{eqnarray*}
Ly = \lambda y.
\end{eqnarray*}

Provided suitable boundary conditions are chosen, the 
S-L operator $L$ is \emph{symmetric}, i.e. :
\begin{eqnarray*}
(Lf,g)=(f,Lg),
\end{eqnarray*}
for any functions $f$ and $g$ in the weighted Hilbert space. 
In cases where complex functions are considered, 
this operator is \emph{self-adjoint} (some authors use the term 
\emph{Hermitian}).

In practice, we must prescribe some appropriate boundary conditions to the 
Sturm-Liouville (S-L) equation. 
If a value $\lambda$ exists, then it is an eigenvalue of the 
S-L equation. 
Under some hypotheses, the eigenvalues $\lambda_1,\lambda_2,...$ of the 
S-L problem are real. 
For each eigenvalue $\lambda_n$, the solution $y_n(x)$ is the 
corresponding eigenvector function. 
The normalized eigenfunctions form an orthonormal basis in the 
weighted Hilbert space associated with the scalar product :
\begin{eqnarray*}
\int_\RR y_n(x) y_m(x) w(x) dx = \delta_{nm},
\end{eqnarray*}
for $n,m\geq 1$.

As we are going to see, all orthogonal polynomials are associated 
with a S-L equation. 

% http://www.iitg.ernet.in/physics/fac/charu/courses/ph402/SturmLiouville.pdf

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Notes and references}

More details on the link between quadrature rules, the 
Lagrangian interpolating polynomial and orthogonal 
polynomials can be found in \cite{Quarteroni2000}, in the 
chapter 10 "Orthogonal polynomials in approximation theory".

The three-term recurrence of orthogonal polynomials 
is presented in \cite{Quarteroni2000}, and proved in \cite{ANU:1770376}.
